//--------------------------------------------------------------
// File     : stm32_ub_adc3_ig.h
//--------------------------------------------------------------

//--------------------------------------------------------------
#ifndef __STM32F4_UB_ADC3_IG_H
#define __STM32F4_UB_ADC3_IG_H


//--------------------------------------------------------------
// Includes
//--------------------------------------------------------------
#include "stm32f4xx.h"
#include "stm32f4xx_gpio.h"
#include "stm32f4xx_rcc.h"
#include "stm32f4xx_adc.h"



//--------------------------------------------------------------
// Liste aller ADC-Kanle
// (keine Nummer doppelt und von 0 beginnend)
//--------------------------------------------------------------
typedef enum {
  ADC_PC3 = 0,  // PC3
  ADC_PF6 = 1   // PF6
}ADC3i_NAME_t;

#define  ADC3i_ANZ   2 // Anzahl von ADC3i_NAME_t (maximal 4 Stck)


//--------------------------------------------------------------
// ADC-Clock
// Max-ADC-Frq = 36MHz
// Grundfrequenz = APB2 (APB2=90MHz) 
// Moegliche Vorteiler = 2,4,6,8
//--------------------------------------------------------------

//#define ADC3i_VORTEILER     ADC_Prescaler_Div2 // Frq = 45 MHz
#define ADC3i_VORTEILER     ADC_Prescaler_Div4   // Frq = 22.5 MHz
//#define ADC3i_VORTEILER     ADC_Prescaler_Div6 // Frq = 15 MHz
//#define ADC3i_VORTEILER     ADC_Prescaler_Div8 // Frq = 11.25 MHz





//--------------------------------------------------------------
// Struktur eines ADC Kanals
//--------------------------------------------------------------
typedef struct {
  ADC3i_NAME_t ADC_NAME;  // Name
  GPIO_TypeDef* ADC_PORT; // Port
  const uint16_t ADC_PIN; // Pin
  const uint32_t ADC_CLK; // Clock
  const uint8_t ADC_CH;   // ADC-Kanal
}ADC3i_t;



//--------------------------------------------------------------
// Globale Funktionen
//--------------------------------------------------------------
void UB_ADC3_IG_Init(void);
uint16_t UB_ADC3_IG_Read(ADC3i_NAME_t adc_name);

//--------------------------------------------------------------
#endif // __STM32F4_UB_ADC3_IG_H
